#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Aug  4 09:50:10 2021

@author: aoehme
"""

import pandas as pd
import numpy as np
import scipy.io as sio
from shapely.geometry import mapping, Polygon
import os
import pandas as pd
import numpy.matlib
import json
import matplotlib.pyplot as plt
import seaborn as sns
from matplotlib.cbook import get_sample_data
import scipy.misc
from scipy import ndimage
from matplotlib.patches import Rectangle
from matplotlib.patches import FancyBboxPatch
import matplotlib.patches as mpatches
from matplotlib.lines import Line2D


#sns.set_style("darkgrid")

sub_sectors = pd.read_pickle(r'/home/aoehme/Documents/Python/Industry/NewFigures/toxic_substances.pkl')

fig = plt.figure(figsize=(15,15))
ax = plt.subplot(111)
width=0.8
sub_sectors_sort=sub_sectors.sort_values(by=['Total'],ascending=False)
sub_sectors_sort=sub_sectors_sort.head(n=20)
#sub_sectors_sort.plot.barh(x='Substance',y={'Energy', 'IPPU', 'AFOLU','Other','Military','Waste' }, rot=0, stacked=True)
ax.barh(sub_sectors_sort['Substance'],sub_sectors_sort['IPPU'],color='#004e89',edgecolor='black',zorder=3)
ax.barh(sub_sectors_sort['Substance'],sub_sectors_sort['Other'],left=sub_sectors_sort['IPPU'],color='#6d6875',edgecolor='black',zorder=3)
ax.barh(sub_sectors_sort['Substance'],sub_sectors_sort['Energy'],left=sub_sectors_sort['IPPU'] + sub_sectors_sort['Other'],color='#69b3a2',edgecolor='black',zorder=3)
ax.barh(sub_sectors_sort['Substance'],sub_sectors_sort['Military'],left=sub_sectors_sort['IPPU'] + sub_sectors_sort['Other'] + sub_sectors_sort['Energy'],color='white',edgecolor='black',zorder=3)
ax.barh(sub_sectors_sort['Substance'],sub_sectors_sort['Waste'],left=sub_sectors_sort['IPPU'] + sub_sectors_sort['Other'] + sub_sectors_sort['Energy'] + sub_sectors_sort['Military'],color='#f48c06',edgecolor='black',zorder=3)
ax.barh(sub_sectors_sort['Substance'],sub_sectors_sort['AFOLU'],left=sub_sectors_sort['IPPU'] + sub_sectors_sort['Other'] + sub_sectors_sort['Energy'] + sub_sectors_sort['Military'] + sub_sectors_sort['Waste'],color='#d00000',edgecolor='black',zorder=3)

labels = [item.get_text() for item in ax.get_yticklabels()]
labels[0] = 'Diesel fuel'
labels[1] = 'Petroleum/\nKerosene'
labels[2] = 'Gasoline SRG/\nNaphtha light'
labels[3] = 'Benzene'
labels[4] = 'Not attributable'
labels[5] = 'Polychlorinated \nbiphenyls \n(Mixture of congeners)'
labels[6] = 'Lead'
labels[7] = 'BTEX (Benzene, \nToluene, Ethylbenzene, \ntotal Xylenes)'
labels[8] = 'Xylenes, \nmixture of isomers'
labels[9] = 'Toluene'
labels[10] = 'Ethylbenzene'
labels[11] = 'Trichloroethylene'
labels[12] = 'Arsenic'
labels[13] = 'Tetrachloroethylene'
labels[14] = 'Naphthalene'
labels[15] = 'Asbestos'
labels[16] = 'Chromium'
labels[17] = '2-Methylnaphthalene'
labels[18] = '1,3,5-Trimethylbenzene'
labels[19] = 'Mercury'

ax.grid(zorder=0)
ax.set_yticklabels(labels,fontsize=12,fontweight='bold')
plt.xticks(fontsize=12,fontweight='bold')
#ax.legend(["Energy","IPPU","AFOLU","Other","Military","Waste"], loc='upper right', fontsize=16) 
ax.set_xlabel('Occurence',fontsize=14,fontweight='bold')

im = plt.imread(get_sample_data(r'/home/aoehme/Documents/Python/Industry/NewFigures/fish.png'))
rotated_im = ndimage.rotate(im, 45)
#Mercury
newax = fig.add_axes([0.18, 0.93, 0.05, 0.05], anchor='NE', zorder=5)
newax.imshow(rotated_im)
newax2 = fig.add_axes([0.21, 0.93, 0.05, 0.05], anchor='NE', zorder=5)
newax2.imshow(rotated_im)
newax3 = fig.add_axes([0.24, 0.93, 0.05, 0.05], anchor='NE', zorder=5)
newax3.imshow(rotated_im)
newax4 = fig.add_axes([0.27, 0.93, 0.05, 0.05], anchor='NE', zorder=5)
newax4.imshow(rotated_im)
#Diesel
newax5 = fig.add_axes([0.936, 0.05, 0.05, 0.05], anchor='NE', zorder=5)
newax5.imshow(rotated_im)
#Petroleum
newax6 = fig.add_axes([0.68, 0.097, 0.05, 0.05], anchor='NE', zorder=5)
newax6.imshow(rotated_im)
newax7 = fig.add_axes([0.71, 0.097, 0.05, 0.05], anchor='NE', zorder=5)
newax7.imshow(rotated_im)
#Gasoline
newax8 = fig.add_axes([0.485, 0.143, 0.05, 0.05], anchor='NE', zorder=5)
newax8.imshow(rotated_im)
#Benzene
newax9 = fig.add_axes([0.315, 0.189, 0.05, 0.05], anchor='NE', zorder=5)
newax9.imshow(rotated_im)
newax10 = fig.add_axes([0.345, 0.189, 0.05, 0.05], anchor='NE', zorder=5)
newax10.imshow(rotated_im)
#Other
ax.text(150, 3.75, "?", fontsize=26, fontweight="bold")
#Polychlorinated biphenyls
newax11 = fig.add_axes([0.295, 0.282, 0.05, 0.05], anchor='NE', zorder=5)
newax11.imshow(rotated_im)
newax12 = fig.add_axes([0.325, 0.282, 0.05, 0.05], anchor='NE', zorder=5)
newax12.imshow(rotated_im)
#Lead
newax13 = fig.add_axes([0.26, 0.328, 0.05, 0.05], anchor='NE', zorder=5)
newax13.imshow(rotated_im)
newax14 = fig.add_axes([0.29, 0.328, 0.05, 0.05], anchor='NE', zorder=5)
newax14.imshow(rotated_im)
newax15 = fig.add_axes([0.32, 0.328, 0.05, 0.05], anchor='NE', zorder=5)
newax15.imshow(rotated_im)
#BTEX
newax16 = fig.add_axes([0.25, 0.375, 0.05, 0.05], anchor='NE', zorder=5)
newax16.imshow(rotated_im)
newax17 = fig.add_axes([0.28, 0.375, 0.05, 0.05], anchor='NE', zorder=5)
newax17.imshow(rotated_im)
#Xylenes
newax18 = fig.add_axes([0.248, 0.421, 0.05, 0.05], anchor='NE', zorder=5)
newax18.imshow(rotated_im)
newax19 = fig.add_axes([0.278, 0.421, 0.05, 0.05], anchor='NE', zorder=5)
newax19.imshow(rotated_im)
#Toluene
newax20 = fig.add_axes([0.235, 0.467, 0.05, 0.05], anchor='NE', zorder=5)
newax20.imshow(rotated_im)
newax21 = fig.add_axes([0.265, 0.467, 0.05, 0.05], anchor='NE', zorder=5)
newax21.imshow(rotated_im)
#Ethylbenzene
newax22 = fig.add_axes([0.225, 0.513, 0.05, 0.05], anchor='NE', zorder=5)
newax22.imshow(rotated_im)
newax23 = fig.add_axes([0.255, 0.513, 0.05, 0.05], anchor='NE', zorder=5)
newax23.imshow(rotated_im)
#Trichlorethylene
newax24 = fig.add_axes([0.21, 0.559, 0.05, 0.05], anchor='NE', zorder=5)
newax24.imshow(rotated_im)
newax25 = fig.add_axes([0.24, 0.559, 0.05, 0.05], anchor='NE', zorder=5)
newax25.imshow(rotated_im)
#Arsenic
newax26 = fig.add_axes([0.2, 0.605, 0.05, 0.05], anchor='NE', zorder=5)
newax26.imshow(rotated_im)
newax27 = fig.add_axes([0.23, 0.605, 0.05, 0.05], anchor='NE', zorder=5)
newax27.imshow(rotated_im)
newax28 = fig.add_axes([0.26, 0.605, 0.05, 0.05], anchor='NE', zorder=5)
newax28.imshow(rotated_im)
#Tetrachloroethylene
newax29 = fig.add_axes([0.2, 0.652, 0.05, 0.05], anchor='NE', zorder=5)
newax29.imshow(rotated_im)
newax30 = fig.add_axes([0.23, 0.652, 0.05, 0.05], anchor='NE', zorder=5)
newax30.imshow(rotated_im)
#Naphthalene
newax31 = fig.add_axes([0.195, 0.699, 0.05, 0.05], anchor='NE', zorder=5)
newax31.imshow(rotated_im)
newax32 = fig.add_axes([0.225, 0.699, 0.05, 0.05], anchor='NE', zorder=5)
newax32.imshow(rotated_im)
newax33 = fig.add_axes([0.255, 0.699, 0.05, 0.05], anchor='NE', zorder=5)
newax33.imshow(rotated_im)
#Asbestos
#No impact on fish
#Chromium
newax34 = fig.add_axes([0.185, 0.791, 0.05, 0.05], anchor='NE', zorder=5)
newax34.imshow(rotated_im)
newax35 = fig.add_axes([0.215, 0.791, 0.05, 0.05], anchor='NE', zorder=5)
newax35.imshow(rotated_im)
#2Methylnaphthalene
newax36 = fig.add_axes([0.185, 0.837, 0.05, 0.05], anchor='NE', zorder=5)
newax36.imshow(rotated_im)
newax37 = fig.add_axes([0.215, 0.837, 0.05, 0.05], anchor='NE', zorder=5)
newax37.imshow(rotated_im)
newax38 = fig.add_axes([0.245, 0.837, 0.05, 0.05], anchor='NE', zorder=5)
newax38.imshow(rotated_im)
#1,3,5-Trimethylbenzene
newax39 = fig.add_axes([0.185, 0.883, 0.05, 0.05], anchor='NE', zorder=5)
newax39.imshow(rotated_im)
newax40 = fig.add_axes([0.215, 0.883, 0.05, 0.05], anchor='NE', zorder=5)
newax40.imshow(rotated_im)

#Axis
newax.axis('off')
newax2.axis('off')
newax3.axis('off')
newax4.axis('off')
newax5.axis('off')
newax6.axis('off')
newax7.axis('off')
newax8.axis('off')
newax9.axis('off')
newax10.axis('off')
newax11.axis('off')
newax12.axis('off')
newax13.axis('off')
newax14.axis('off')
newax15.axis('off')
newax16.axis('off')
newax17.axis('off')
newax18.axis('off')
newax19.axis('off')
newax20.axis('off')
newax21.axis('off')
newax22.axis('off')
newax23.axis('off')
newax24.axis('off')
newax25.axis('off')
newax26.axis('off')
newax27.axis('off')
newax28.axis('off')
newax29.axis('off')
newax30.axis('off')
newax31.axis('off')
newax32.axis('off')
newax33.axis('off')
newax34.axis('off')
newax35.axis('off')
newax36.axis('off')
newax37.axis('off')
newax38.axis('off')
newax39.axis('off')
newax40.axis('off')

#ax.add_patch(Rectangle((620,13.96),200,5.9,facecolor = '#f0f0f0',edgecolor='grey',lw=2,alpha=0.8,capstyle='round'))
ax.add_patch(FancyBboxPatch((615,14.0),180,5.3,facecolor = '#f9f9f9',edgecolor='#bababa',lw=2,boxstyle='round',alpha=0.7,zorder=5))
#Custom Legend
newax41 = fig.add_axes([0.80, 0.78, 0.035, 0.035], anchor='NE', zorder=5)
newax41.imshow(rotated_im)
newax42 = fig.add_axes([0.82, 0.78, 0.035, 0.035], anchor='NE', zorder=5)
newax42.imshow(rotated_im)
newax43 = fig.add_axes([0.84, 0.78, 0.035, 0.035], anchor='NE', zorder=5)
newax43.imshow(rotated_im)
newax44 = fig.add_axes([0.86, 0.78, 0.035, 0.035], anchor='NE', zorder=5)
newax44.imshow(rotated_im)

newax41.axis('off')
newax42.axis('off')
newax43.axis('off')
newax44.axis('off')

newax45 = fig.add_axes([0.82, 0.76, 0.035, 0.035], anchor='NE', zorder=5)
newax45.imshow(rotated_im)
newax46 = fig.add_axes([0.84, 0.76, 0.035, 0.035], anchor='NE', zorder=5)
newax46.imshow(rotated_im)
newax47 = fig.add_axes([0.86, 0.76, 0.035, 0.035], anchor='NE', zorder=5)
newax47.imshow(rotated_im)

newax45.axis('off')
newax46.axis('off')
newax47.axis('off')

newax48 = fig.add_axes([0.84, 0.74, 0.035, 0.035], anchor='NE', zorder=5)
newax48.imshow(rotated_im)
newax49 = fig.add_axes([0.86, 0.74, 0.035, 0.035], anchor='NE', zorder=5)
newax49.imshow(rotated_im)

newax48.axis('off')
newax49.axis('off')

newax50 = fig.add_axes([0.86, 0.72, 0.035, 0.035], anchor='NE', zorder=5)
newax50.imshow(rotated_im)

newax50.axis('off')

patch1 = mpatches.Patch(facecolor="#004e89",edgecolor='black',alpha=1,label="IPPU")
patch2 = mpatches.Patch(facecolor='#6d6875',edgecolor='black',alpha=1,label="Other")
patch3 = mpatches.Patch(facecolor='#69b3a2',edgecolor='black',alpha=1,label="Energy")
patch4 = mpatches.Patch(facecolor='white',edgecolor='black',alpha=1,label="Military")
patch5 = mpatches.Patch(facecolor='#f48c06',edgecolor='black',alpha=1,label="Waste")
patch6 = mpatches.Patch(facecolor='#d00000',edgecolor='black',alpha=1,label="AFOLU")
title_patch = Line2D([0],[0],color='white',alpha=0,label="")
title_patch2 = Line2D([0],[0],color='white',alpha=0,label="")
patch7 = Line2D([0],[0],color='white',alpha=0,label="<1")
patch8 = Line2D([0],[0],color='white',alpha=0,label="1-10")
patch9 = Line2D([0],[0],color='white',alpha=0,label="10-100")
patch10 = Line2D([0],[0],color='white',alpha=0,label="100-1000")
legend = ax.legend(handles=[patch1,patch2,patch3,patch4,patch5,patch6,title_patch,title_patch2,patch7,patch8,patch9,patch10],loc="upper right",fontsize=16) #,loc="upper right" ,borderpad=1,labelspacing=1.5 bbox_to_anchor=(0.0,0.0,0.98,0.98),    
legend.get_frame().set_linewidth(0.0)
legend.get_frame().set_facecolor('none')

ax.text(628, 16.1, "LC$_{50}$ Fish [mg/l]", fontsize=16, fontweight="bold",zorder=5)
ax.set_ylim(-0.7,19.7)

fig.tight_layout()

#fig.savefig('/home/aoehme/Documents/Python/Industry/NewFigures/SubstancePlot_v3.png')